<template>
  <q-btn color="red-8" label="Kies entrypoint" style="width: 200px;" class="q-mr-lg q-mt-sm" tabindex="0">
    <q-menu class="fixed">
      <div class="menu_outer">
      <q-input label="filter" v-model="search_value" class="bg_detail ep_filter" autofocus tabindex="0">
        <template v-slot:prepend>
          <q-icon name="filter_alt"/>
        </template>
      </q-input>
      <q-list class="q-mt-md list_outer" tabindex=0>
        <q-item v-for="dts in dtslist_filtered" :key="dts.name" clickable @click="go_dts(dts.name)" dense>
          {{ dts.nice_name }}
        </q-item>
      </q-list>
      </div>
    </q-menu>
  </q-btn>
</template>

<script>
import {api} from 'boot/axios';
import _ from 'lodash';
import SharedMethods from "components/SharedMethods";

export default {
  name: "DtsDropdownlist.vue",
  data() {
    return {
      dtslist: [{name: undefined}],
      current_nt_version: undefined,
      search_value: undefined
    }
  },
  created() {
    this.current_nt_version = SharedMethods.get_nt_version()
    this.fetchData()
  },
  watch: {
    "$route.query.nt_version": function () {
      this.current_nt_version = this.$route.query.nt_version
      this.fetchData()
    }
  },

  methods: {
    go_dts: function (dts_name) {
      this.$router.push({path: "/dts/"+ this.current_nt_version + "/" + dts_name})
    },
    fetchData: function () {
      api
        .get("/dts", {params: {nt_version: this.current_nt_version}})
        .then(response => (this.dtslist = response.data))
    }
  },
  computed: {
    dtslist_filtered() {
      if (!_.isUndefined(this.search_value) && this.search_value.length > 1) {
        return this.dtslist.filter(dts => dts.nice_name &&
          dts.nice_name.toLowerCase().includes(this.search_value.toLowerCase()))
      }
      return this.dtslist
    }
  }
}
</script>

<style scoped lang="scss">
.menu_outer {
  position: relative;
}
.ep_filter {
  position: sticky;
  top: 0;
  width: 100%;
  background: $detail_bg;
  z-index: 10000;
  border: 10px solid white;
}
</style>
